unit uGUI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin;

type
  TGUI = class(TForm)
    PTitel: TPanel;
    GBQuelltext: TGroupBox;
    GBChiffre: TGroupBox;
    GBSchluessel: TGroupBox;
    SpEdSchluessel: TSpinEdit;
    MQuelltext: TMemo;
    BLadenQ: TButton;
    BSpeichernQ: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    GBGeheimtext: TGroupBox;
    MGeheimtext: TMemo;
    BLadenG: TButton;
    BSpeichernG: TButton;
    OpenDialog2: TOpenDialog;
    SaveDialog2: TSaveDialog;
    BVorbereiten: TButton;
    BLoeschen1: TButton;
    BLoeschen2: TButton;
    BVerschluesseln: TButton;
    BEntschluesseln: TButton;
    BUebernehmen: TButton;
    procedure BVerschluesselnClick(Sender: TObject);
    procedure BEntschluesselnClick(Sender: TObject);
    procedure BLadenQClick(Sender: TObject);
    procedure BSpeichernQClick(Sender: TObject);
    procedure BLadenGClick(Sender: TObject);
    procedure BSpeichernGClick(Sender: TObject);
    procedure BVorbereitenClick(Sender: TObject);
    procedure BLoeschen1Click(Sender: TObject);
    procedure BLoeschen2Click(Sender: TObject);
    procedure BUebernehmenClick(Sender: TObject);
  private
    { Private-Deklarationen }
    quelltext: string;
    geheimtext: string;
    schluessel: integer;
    procedure verschluesseln;
    procedure entschluesseln;
    procedure vorbereiten;
  public
    { Public-Deklarationen }
  end;

var
  GUI: TGUI;

implementation

{$R *.DFM}

procedure TGUI.verschluesseln;
  var i, n: integer;
begin
  geheimtext := '';
  for i := 1 to length(quelltext) do
  begin
    n := ord(quelltext[i]);
    n := n + Schluessel;
    if n > 90 then n := n-26;
    geheimtext := geheimtext + chr(n);
  end
end;

procedure TGUI.entschluesseln;
  var i, n: integer;
begin
  quelltext := '';
  for i := 1 to length(geheimtext) do
  begin
    n := ord(geheimtext[i]);
    n := n - Schluessel;
    if n < 65 then n := n+26;
    quelltext := quelltext + chr(n);
  end
end;

procedure TGUI.vorbereiten;
  var c: char;
      i: integer;
      hilfstext: string;
begin
  Hilfstext := '';
  for i := 1 to length(quelltext) do
  begin
    c := quelltext[i];
    case c of
      'A'..'Z': hilfstext := hilfstext + c;
      '0'..'9': hilfstext := hilfstext + c;
      'a'..'z': hilfstext := hilfstext + chr(ord(c)-32);
      '': hilfstext := hilfstext + 'SS';
      '': hilfstext := hilfstext + 'AE';
      '': hilfstext := hilfstext + 'OE';
      '': hilfstext := hilfstext + 'UE';
      '': hilfstext := hilfstext + 'AE';
      '': hilfstext := hilfstext + 'OE';
      '': hilfstext := hilfstext + 'UE';
    end;
  end;
  quelltext := hilfstext;
end;

procedure TGUI.BVerschluesselnClick(Sender: TObject);
begin
  // Eingabe
  quelltext := MQuelltext.Text;
  // Verarbeitung
  verschluesseln;
  // Ausgabe
  MGeheimtext.Text := geheimtext;
end;

procedure TGUI.BEntschluesselnClick(Sender: TObject);
begin
  // Eingabe
  geheimtext := MGeheimtext.Text;
  // Verarbeitung
  entschluesseln;
  // Ausgabe
  MQuelltext.Text := quelltext;
end;

procedure TGUI.BVorbereitenClick(Sender: TObject);
begin
  // Eingabe
  quelltext := MQuelltext.Text;
  // Verarbeitung
  vorbereiten;
  // Ausgabe
  MQuelltext.Text := quelltext;
end;

procedure TGUI.BLadenQClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    MQuelltext.Lines.LoadFromFile(OpenDialog1.Filename);
end;

procedure TGUI.BSpeichernQClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
    MQuelltext.Lines.SaveToFile(SaveDialog1.Filename);
end;

procedure TGUI.BLadenGClick(Sender: TObject);
begin
  if OpenDialog2.Execute then
    MGeheimtext.Lines.LoadFromFile(OpenDialog2.Filename);
end;

procedure TGUI.BSpeichernGClick(Sender: TObject);
begin
  if SaveDialog2.Execute then
    MGeheimtext.Lines.SaveToFile(SaveDialog2.Filename);
end;

procedure TGUI.BLoeschen1Click(Sender: TObject);
begin
  MQuelltext.Lines.Clear;
end;

procedure TGUI.BLoeschen2Click(Sender: TObject);
begin
  MGeheimtext.Lines.Clear;
end;

procedure TGUI.BUebernehmenClick(Sender: TObject);
begin
  Schluessel := SpEdSchluessel.Value;
end;

end.


