unit uChiffrierer;

interface

type
  TChiffrierer = class
  private
    quelltext: string;
    geheimtext: string;
    schluessel: integer;
  public
    constructor create;
    procedure setQuelltext(t: string);
    function getQuelltext: string;
    procedure setGeheimtext(t: string);
    function getGeheimtext: string;
    procedure setSchluessel(s: integer);
    function getSchluessel: integer;
    procedure vorbereiten;
    procedure verschluesseln;
    procedure entschluesseln;
  end;

implementation

constructor TChiffrierer.create;
begin
  quelltext := '';
  geheimtext := '';
  schluessel := 0;
end;

procedure TChiffrierer.setQuelltext(t: string);
begin
  quelltext := t;
end;

function TChiffrierer.getQuelltext: string;
begin
  result := quelltext;
end;

procedure TChiffrierer.setGeheimtext(t: string);
begin
  geheimtext := t;
end;

function TChiffrierer.getGeheimtext: string;
begin
  result := geheimtext;
end;

procedure TChiffrierer.setSchluessel(s: integer);
begin
  schluessel := s;
end;

function TChiffrierer.getSchluessel: integer;
begin
  result := schluessel;
end;

procedure TChiffrierer.vorbereiten;
  var c: char;
      i: integer;
      hilfstext: string;
begin
  hilfstext := '';
  for i := 1 to length(quelltext) do
  begin
    c := quelltext[i];
    case c of
      'A'..'Z': hilfstext := hilfstext + c;
      '0'..'9': hilfstext := hilfstext + c;
      'a'..'z': hilfstext := hilfstext + chr(ord(c)-32);
      '': hilfstext := hilfstext + 'SS';
      '': hilfstext := hilfstext + 'AE';
      '': hilfstext := hilfstext + 'OE';
      '': hilfstext := hilfstext + 'UE';
      '': hilfstext := hilfstext + 'AE';
      '': hilfstext := hilfstext + 'OE';
      '': hilfstext := hilfstext + 'UE';
    end;
  end;
  quelltext := hilfstext;
end;

procedure TChiffrierer.verschluesseln;
  var i, n: integer;
begin
  geheimtext := '';
  for i := 1 to length(quelltext) do
  begin
    n := ord(quelltext[i]);
    n := n + Schluessel;
    if n > 90 then n := n-26;
    geheimtext := geheimtext + chr(n);
  end
end;

procedure TChiffrierer.entschluesseln;
  var i, n: integer;
begin
  quelltext := '';
  for i := 1 to length(geheimtext) do
  begin
    n := ord(geheimtext[i]);
    n := n - Schluessel;
    if n < 65 then n := n+26;
    quelltext := quelltext + chr(n);
  end
end;


end.
