unit uGUI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin, uChiffrierer;

type
  TGUI = class(TForm)
    PTitel: TPanel;
    GBQuelltext: TGroupBox;
    GBChiffre: TGroupBox;
    GBSchluessel: TGroupBox;
    SpEdSchluessel: TSpinEdit;
    MQuelltext: TMemo;
    BLadenQ: TButton;
    BSpeichernQ: TButton;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    GBGeheimtext: TGroupBox;
    MGeheimtext: TMemo;
    BLadenG: TButton;
    BSpeichernG: TButton;
    OpenDialog2: TOpenDialog;
    SaveDialog2: TSaveDialog;
    BVorbereiten: TButton;
    BLoeschen1: TButton;
    BLoeschen2: TButton;
    BVerschluesseln: TButton;
    BEntschluesseln: TButton;
    BUebernehmen: TButton;
    procedure BVerschluesselnClick(Sender: TObject);
    procedure BEntschluesselnClick(Sender: TObject);
    procedure BLadenQClick(Sender: TObject);
    procedure BSpeichernQClick(Sender: TObject);
    procedure BLadenGClick(Sender: TObject);
    procedure BSpeichernGClick(Sender: TObject);
    procedure BVorbereitenClick(Sender: TObject);
    procedure BLoeschen1Click(Sender: TObject);
    procedure BLoeschen2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BUebernehmenClick(Sender: TObject);
  private
    { Private-Deklarationen }
    chiffrierer: TChiffrierer;
  public
    { Public-Deklarationen }
  end;

var
  GUI: TGUI;

implementation

{$R *.DFM}

procedure TGUI.FormCreate(Sender: TObject);
begin
  chiffrierer := TChiffrierer.create;
end;

procedure TGUI.BVerschluesselnClick(Sender: TObject);
begin
  chiffrierer.setQuelltext(MQuelltext.Text);
  chiffrierer.verschluesseln;
  MGeheimtext.Text := chiffrierer.getGeheimtext;
end;

procedure TGUI.BEntschluesselnClick(Sender: TObject);
begin
  chiffrierer.setGeheimtext(MGeheimtext.Text);
  chiffrierer.entschluesseln;
  MQuelltext.Text := chiffrierer.getQuelltext;
end;

procedure TGUI.BVorbereitenClick(Sender: TObject);
begin
  chiffrierer.setQuelltext(MQuelltext.Text);
  chiffrierer.vorbereiten;
  MQuelltext.Text := chiffrierer.getQuelltext;
end;

procedure TGUI.BLadenQClick(Sender: TObject);
begin
  if OpenDialog1.Execute then
    MQuelltext.Lines.LoadFromFile(OpenDialog1.Filename);
end;

procedure TGUI.BSpeichernQClick(Sender: TObject);
begin
  if SaveDialog1.Execute then
    MQuelltext.Lines.SaveToFile(SaveDialog1.Filename);
end;

procedure TGUI.BLadenGClick(Sender: TObject);
begin
  if OpenDialog2.Execute then
    MGeheimtext.Lines.LoadFromFile(OpenDialog2.Filename);
end;

procedure TGUI.BSpeichernGClick(Sender: TObject);
begin
  if SaveDialog2.Execute then
    MGeheimtext.Lines.SaveToFile(SaveDialog2.Filename);
end;

procedure TGUI.BLoeschen1Click(Sender: TObject);
begin
  MQuelltext.Lines.Clear;
end;

procedure TGUI.BLoeschen2Click(Sender: TObject);
begin
  MGeheimtext.Lines.Clear;
end;

procedure TGUI.BUebernehmenClick(Sender: TObject);
begin
  chiffrierer.setSchluessel(SpEdSchluessel.Value);
end;

end.


