unit uGUI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls,
  uWuerfel, uSpielbrett, uKonto;

type
  TGUI = class(TForm)
    PTitel: TPanel;
    GBWuerfel: TGroupBox;
    GBKonto: TGroupBox;
    PWuerfelA: TPanel;
    PWuerfelB: TPanel;
    PWuerfelC: TPanel;
    PKonto: TPanel;
    RGSpielbrett: TRadioGroup;
    BGewinnVerbuchen: TButton;
    BWuerfelWerfen: TButton;
    BEinsatzZahlen: TButton;
    procedure FormCreate(Sender: TObject);
    procedure RGSpielbrettClick(Sender: TObject);
    procedure BGewinnVerbuchenClick(Sender: TObject);
    procedure BWuerfelWerfenClick(Sender: TObject);
    procedure BEinsatzZahlenClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private-Deklarationen }
    wuerfelA, wuerfelB, wuerfelC: TWuerfel;
    spielbrett: TSpielbrett;
    konto: TKonto;
  public
    { Public-Deklarationen }
  end;

var
  GUI: TGUI;


implementation

{$R *.DFM}

procedure TGUI.FormCreate(Sender: TObject);
begin
  randomize;
  // Erzeugung der Objekte
  wuerfelA := TWuerfel.create;
  wuerfelB := TWuerfel.create;
  wuerfelC := TWuerfel.create;
  konto := TKonto.create(100);
  spielbrett := TSpielbrett.create;
  // Aktualisierung der Anzeige
  PWuerfelA.Caption  := IntToStr(wuerfelA.getAugen);
  PWuerfelB.Caption  := IntToStr(wuerfelB.getAugen);
  PWuerfelC.Caption  := IntToStr(wuerfelC.getAugen);
  PKonto.Caption := IntToStr(konto.getStand);
end;


procedure TGUI.RGSpielbrettClick(Sender: TObject);
  var tipp: integer;
begin
  tipp := RGSpielbrett.ItemIndex+1;
  spielbrett.setzen(tipp);
end;

procedure TGUI.BGewinnVerbuchenClick(Sender: TObject);
  var treffer, tipp: integer;
begin
  tipp := spielbrett.getZahl;
  treffer := 0;
  if wuerfelA.getAugen = tipp then inc(treffer);
  if wuerfelB.getAugen = tipp then inc(treffer);
  if wuerfelC.getAugen = tipp then inc(treffer);
  // Aktualisierung der Modell-Objekte
  if treffer > 0 then konto.einzahlen(treffer + 1);
  // Aktualisierung der Anzeige
  PKonto.Caption := IntToStr(konto.getStand);
end;

procedure TGUI.BWuerfelWerfenClick(Sender: TObject);
begin
  // Aktualisierung der Modell-Objekte
  wuerfelA.werfen;
  wuerfelB.werfen;
  wuerfelC.werfen;
  // Aktualisierung der Anzeige
  PWuerfelA.Caption  := IntToStr(wuerfelA.getAugen);
  PWuerfelB.Caption  := IntToStr(wuerfelB.getAugen);
  PWuerfelC.Caption  := IntToStr(wuerfelC.getAugen);
end;

procedure TGUI.BEinsatzZahlenClick(Sender: TObject);
begin
  // Aktualisierung des Modells
  konto.abheben(1);
  // Aktualisierung der Anzeige
  PKonto.Caption := IntToStr(konto.getStand);
end;

procedure TGUI.FormDestroy(Sender: TObject);
begin
  spielbrett.free;
  konto.free;
  wuerfelC.free;
  wuerfelB.free;
  wuerfelA.free;
end;

end.
