unit uGUI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  tRichtung = (sueden, westen, norden, osten);

type
  tRoboter = record
               xpos: integer;
               ypos: integer;
               richtung: tRichtung;
             end;

type
  TGUI = class(TForm)
    IZeichnen: TImage;
    PSteuerung: TPanel;
    BInitialisieren: TButton;
    BLinks: TButton;
    BSchritt: TButton;
    BRechts: TButton;
    procedure BInitialisierenClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BLinksClick(Sender: TObject);
    procedure BRechtsClick(Sender: TObject);
    procedure BSchrittClick(Sender: TObject);

  private
    { Private-Deklarationen }
    roboter: tRoboter;
    procedure roboterInitialisieren;
    procedure schritt;
    procedure linksDrehen;
    procedure rechtsDrehen;
    procedure weltZeichnen;
    procedure roboterZeichnen;
    procedure dreieckOsten(x1, y1, x2, y2: integer);
    procedure dreieckSueden(x1, y1, x2, y2: integer);
    procedure dreieckWesten(x1, y1, x2, y2: integer);
    procedure dreieckNorden(x1, y1, x2, y2: integer);
  public
    { Public-Deklarationen }
  end;

var
  GUI: TGUI;

implementation

{$R *.DFM}

procedure TGUI.dreieckOsten(x1, y1, x2, y2: integer);
begin
  with IZeichnen.Canvas do
  begin
    Pen.Color := clBlack;
    Brush.Color := clBlack;
    Polygon([Point(x1, y1), Point(x2, (y1+y2) div 2), Point(x1, y2)]);
  end;
end;

procedure TGUI.dreieckSueden(x1, y1, x2, y2: integer);
begin
  with IZeichnen.Canvas do
  begin
    Pen.Color := clBlack;
    Brush.Color := clBlack;
    Polygon([Point(x1, y1), Point(x2, y1), Point((x1+x2) div 2, y2)]);
  end;
end;

procedure TGUI.dreieckWesten(x1, y1, x2, y2: integer);
begin
  with IZeichnen.Canvas do
  begin
    Pen.Color := clBlack;
    Brush.Color := clBlack;
    Polygon([Point(x2, y1), Point(x1, (y1+y2) div 2), Point(x2, y2)]);
  end;
end;

procedure TGUI.dreieckNorden(x1, y1, x2, y2: integer);
begin
  with IZeichnen.Canvas do
  begin
    Pen.Color := clBlack;
    Brush.Color := clBlack;
    Polygon([Point(x1, y2), Point(x2, y2), Point((x1+x2) div 2, y1)]);
  end;
end;

procedure TGUI.roboterInitialisieren;
begin
  roboter.xpos := 0;
  roboter.ypos := 0;
  roboter.richtung := sueden;
end;

procedure TGUI.schritt;
begin
  with roboter do
    case richtung of
      sueden: if ypos < 9 then ypos := ypos + 1;
      westen: if xpos > 0 then xpos := xpos - 1;
      norden: if ypos > 0 then ypos := ypos - 1;
      osten : if xpos < 9 then xpos := xpos + 1;
    end;
end;

procedure TGUI.rechtsDrehen;
begin
  with roboter do
    case richtung of
      sueden: richtung := westen;
      westen: richtung := norden;
      norden: richtung := osten;
      osten : richtung := sueden;
    end;
end;

procedure TGUI.linksDrehen;
begin
  with roboter do
    case richtung of
      sueden: richtung := osten;
      westen: richtung := sueden;
      norden: richtung := westen;
      osten : richtung := norden;
    end;
end;

procedure TGUI.weltZeichnen;
  var i, j: integer;
begin
  with IZeichnen.Canvas do
  begin
    Pen.Color := clBlue;
    Brush.Color := clWhite;
    for i := 0 to 9 do
      for j := 0 to 9 do
        Rectangle(i*40, j*40, (i+1)*40, (j+1)*40);
  end;
end;

procedure TGUI.roboterZeichnen;
begin
  with IZeichnen.Canvas do
    with roboter do
      case roboter.richtung of
        osten : dreieckOsten(xpos*40, ypos*40, (xpos+1)*40, (ypos+1)*40);
        sueden: dreieckSueden(xpos*40, ypos*40, (xpos+1)*40, (ypos+1)*40);
        westen: dreieckWesten(xpos*40, ypos*40, (xpos+1)*40, (ypos+1)*40);
        norden: dreieckNorden(xpos*40, ypos*40, (xpos+1)*40, (ypos+1)*40);
      end;
end;

procedure TGUI.FormCreate(Sender: TObject);
begin
  // Datenmodell aktualisieren
  roboterInitialisieren;
  // Anzeige aktualisieren
  weltZeichnen;
  roboterZeichnen;
end;

procedure TGUI.BInitialisierenClick(Sender: TObject);
begin
  // Datenmodell aktualisieren
  roboterInitialisieren;
  // Anzeige aktualisieren
  weltZeichnen;
  roboterZeichnen;
end;

procedure TGUI.BLinksClick(Sender: TObject);
begin
  // Datenmodell aktualisieren
  linksDrehen;
  // Anzeige aktualisieren
  weltZeichnen;
  roboterZeichnen;
end;

procedure TGUI.BRechtsClick(Sender: TObject);
begin
  // Datenmodell aktualisieren
  rechtsDrehen;
  // Anzeige aktualisieren
  weltZeichnen;
  roboterZeichnen;
end;

procedure TGUI.BSchrittClick(Sender: TObject);
begin
  // Datenmodell aktualisieren
  schritt;
  // Anzeige aktualisieren
  weltZeichnen;
  roboterZeichnen;
end;

end.
