unit uRoboter;

interface

type
  tRichtung = (sueden, westen, norden, osten);

type
  TRoboter = class
  private
    xpos: integer;
    ypos: integer;
    richtung: tRichtung;
  public
    constructor create;
    procedure initialisieren;
    procedure schritt;
    procedure rechtsDrehen;
    procedure linksDrehen;
    function getXpos: integer;
    function getYpos: integer;
    function getRichtung: tRichtung;
  end;

implementation

constructor TRoboter.create;
begin
  initialisieren;
end;

procedure TRoboter.initialisieren;
begin
  xPos := 0;
  yPos := 0;
  richtung := sueden;
end;


procedure TRoboter.schritt;
begin
  case richtung of
    sueden: yPos := yPos + 1;
    westen: xPos := xPos - 1;
    norden: yPos := yPos - 1;
    osten : xPos := xPos + 1;
  end;
end;

procedure TRoboter.rechtsDrehen;
begin
  case richtung of
    sueden: richtung := westen;
    westen: richtung := norden;
    norden: richtung := osten;
    osten : richtung := sueden;
  end;
end;

procedure TRoboter.linksDrehen;
begin
  case richtung of
    sueden: richtung := osten;
    westen: richtung := sueden;
    norden: richtung := westen;
    osten : richtung := norden;
  end;
end;

function TRoboter.getXpos: integer;
begin
  result := xPos;
end;

function TRoboter.getYpos: integer;
begin
  result := yPos;
end;

function TRoboter.getRichtung: tRichtung;
begin
  result := richtung;
end;

end.
