unit uGUI;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Spin, uModuloZaehler;

type
  TGUI = class(TForm)
    PTitel: TPanel;
    GBAnzeige: TGroupBox;
    GBKontrolle: TGroupBox;
    PStunde: TPanel;
    PMinute: TPanel;
    SpEdStunde: TSpinEdit;
    SpEdMinute: TSpinEdit;
    BSetzen: TButton;
    BReuckSetzen: TButton;
    BTick: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure BReuckSetzenClick(Sender: TObject);
    procedure BSetzenClick(Sender: TObject);
    procedure BTickClick(Sender: TObject);
  private
    { Private-Deklarationen }
    stundenZaehler: TModuloZaehler;
    minutenZaehler: TModuloZaehler;
  public
    procedure zeitAnzeigen;
    { Public-Deklarationen }
  end;

var
  GUI: TGUI;


implementation

{$R *.DFM}

procedure TGUI.zeitAnzeigen;
begin
  if stundenZaehler.getStand < 10 then
    PStunde.Caption := '0' + IntToStr(stundenZaehler.getStand)
  else
    PStunde.Caption := IntToStr(stundenZaehler.getStand);
  if minutenZaehler.getStand < 10 then
    PMinute.Caption := '0' + IntToStr(minutenZaehler.getStand)
  else
    PMinute.Caption := IntToStr(minutenZaehler.getStand);
end;

procedure TGUI.FormCreate(Sender: TObject);
begin
  stundenZaehler := TModuloZaehler.create(23);
  minutenZaehler := TModuloZaehler.create(59);
  zeitAnzeigen;
end;

procedure TGUI.FormDestroy(Sender: TObject);
begin
  minutenZaehler.free;
  stundenZaehler.free;
end;

procedure TGUI.BReuckSetzenClick(Sender: TObject);
begin
  stundenZaehler.nullSetzen;
  minutenZaehler.nullSetzen;
  zeitAnzeigen;
end;

procedure TGUI.BSetzenClick(Sender: TObject);
begin
  stundenZaehler.setStand(SpEdStunde.value);
  minutenZaehler.setStand(SpEdMinute.value);
  zeitAnzeigen;
end;

procedure TGUI.BTickClick(Sender: TObject);
begin
  minutenZaehler.weiterZaehlen;
  if minutenZaehler.getStand = 0 then
    stundenZaehler.weiterZaehlen;
  zeitAnzeigen;
end;

end.
